package functional.dictionary.oldKey;

final class Dictionary {
	/*@ nullable @*/Key[] keys;
	/*@ nullable @*/Value[] values;

	/*@ 
	  @ requires keys != null && values != null;
	  @ requires (\forall int i,j; 0<=i && i<j && j<keys.length; keys[i] != keys[j]);
	  @ requires keys.length == values.length;
	  @ requires 0<=keys.length && keys.length<Integer.MAX_VALUE;
	  @ ensures (\forall int i; 0<=i&&i<\old(keys.length); \old(keys[i])==k ==> values[i]==v);
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		put(k, v);
	}

	void put(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		int pos = -1;
		int i = 0;
		int keyLen = this.keys.length;
		/*@ maintaining 0<=i && i<=keyLen;
		  @ maintaining (\forall int j; 0<=j && j<i; keys[j]!=k);
		  @ assignable \strictly_nothing;
		  @*/
		while (i < keyLen) {
			if (this.keys[i] == k) {
				pos = i;
				break;
			}
			i = i + 1;
		}

		if (pos >= 0) {
			this.values[pos] = v;
		} else {
            impure();
		}
	}
	/*@ assignable keys, values; @*/
	native void /*@ helper @*/ impure();
}
