package functional.dictionary.sameValues;

final class Dictionary {
	/*@ nullable @*/Key[] keys;
	/*@ nullable @*/Value[] values;

	/*@ 
	  @ requires keys != null && values != null;
	  @ requires (\forall int i,j; 0<=i && i<j && j<keys.length; keys[i] != keys[j]);
	  @ requires keys.length == values.length;
	  @ requires 0<=keys.length && keys.length<Integer.MAX_VALUE;
	  @ ensures (\forall int i; 0<=i && i<values.length; (values[i]!=v ==> values[i]==\old(values[i])) );
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		put(k, v);
	}

	void put(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		int pos = i();

		if (b()) { 
            this.values[pos] = v; 
        } else {
            impure();

            Value[] oldVs = this.values;
			int oldVLen = oldVs.length;
			int iV = 0;
			this.values = new Value[oldVLen + 1];
			this.values[oldVLen] = v;
			/*@ 
			  @ loop_invariant 0<=iV && iV<=oldVs.length;
			  @ loop_invariant (\forall int j; 0<=j && j<iV; values[j]==oldVs[j]);
			  @ loop_invariant values[values.length-1]==v;
			  @ assignable this.values[*];
			  @*/
			while (iV < oldVLen) {
				this.values[iV] = oldVs[iV];
				iV = iV + 1;
			}
		}
	}

	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ b();
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ i();
	/*@ assignable this.keys; @*/
	native void /*@ helper @*/ impure();
}
