package functional.lrs.foundOrNot;

final class LRS {
	int s = 0;
	int t = 0;
	int l = 0;
	/*@ nullable */SuffixArray sa;

	/*@ 
	  @ requires sa!=null && sa.a != null && sa.suffixes != null;
	  @ requires sa.a.length >= 2;
	  @// from class invariants
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; (\exists int j; 0 <= j && j < sa.a.length; sa.suffixes[j]==i));
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; sa.suffixes[i-1] != sa.suffixes[i]);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; 
	  @   (sa.a != null && 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length && 0 <= sa.suffixes[i-1] && sa.suffixes[i-1] < sa.a.length) 
	  @	  ==> (\exists int j; 0 <= j && j < sa.a.length-sa.suffixes[i];
	  @           ((j < sa.a.length-sa.suffixes[i-1] && sa.a[sa.suffixes[i]+j] > sa.a[sa.suffixes[i-1]+j] ) || j == sa.a.length-sa.suffixes[i-1])
	  @               && (\forall int k; 0 <= k && k < j; sa.a[sa.suffixes[i]+k] == sa.a[sa.suffixes[i-1]+k])));
	  @ requires sa.a.length == sa.suffixes.length;
      @ ensures s != t || l == 0;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ int[] array) {
		doLRS(array);
	}

	void doLRS(int[] array) {
		int s = 0;
		int t = 0;
		int l = 0;

		int[] suffixA = sa.suffixes;
        int len = sa.a.length;
		int x = 1;
		/*@ 
		  @ loop_invariant s != t || l == 0;
		  @ assignable \strictly_nothing;
		  @*/
		while (x < len) {
			int begin = suffixA[x];
			int end = suffixA[x - 1];
			if (b()) {
				s = begin;
				t = end;
				l = i();
			}
			x = x + 1;
		}
		this.s = s;
		this.t = t;
		this.l = l;
	}
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ i();
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ b();
}
