package functional.set.emptySet;

final class Set {
	/*@ nullable @*/int[] items;
	/*@ nullable @*/ Set res;

	/*@ 
	  @ requires this.items != null;
	  @ requires (\forall int i, j; 0<=i && i<this.items.length && 0<=j && j<this.items.length && i!=j; this.items[i] != this.items[j]);
	  @ requires 0 <= this.items.length;
	  @ requires p!=null && p.items != null;
	  @ requires (\forall int i, j; 0<=i && i<p.items.length && 0<=j && j<p.items.length && i!=j; p.items[i] != p.items[j]);
	  @ requires 0 <= p.items.length;
	  @ 
	  @ ensures (\old(this.items.length) == 0 || \old(p.items.length) == 0) ==> res.items.length == 0;
	  @ assignable \everything;
	  @ diverges true;
	  @*/
	void wrapper(/*@ nullable @*/ Set p) {
		intersect(p);
	}

	void intersect(/*@ nullable @*/ Set p) {
		res = new Set();
		res.items = new int[0];
		int len = this.items.length;
		int index = 0;
		/*@ loop_invariant 0 <= index && index <=len;		  
		  @ loop_invariant (len == 0 || p.items.length == 0) ==> res.items.length == 0;
		  @ assignable res.items;
		  @*/
		while (index < len) {
			boolean found = false;
			int pLen = p.items.length;
			int pIndex = 0;
			/*@ 
			  @ loop_invariant pLen == 0 ==> !found;
			  @ loop_invariant 0<=pIndex && pIndex<=pLen;
			  @ assignable \strictly_nothing;
			  @*/
			while (pIndex < pLen) {
				if ( b() ) { //				if (p.items[pIndex] == v) {
					found = true;
					break;
				}
				pIndex = pIndex + 1;
			}

			if (found) {
				res.items = _ArrayInt(); //					res.items = newList;
			}
			index = index + 1;
		}
	}
	/*@ assignable \strictly_nothing; @*/
	native int[] /*@ helper @*/ _ArrayInt();
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ b();
}
