package functional.list.subset;

final class List {

	/*@ nullable @*/ int[] list;

	/*@ 
	  @ requires a!=null && a.length >= 0;
	  @ ensures (\forall int i; 0<=i && i<list.length; (\exists int j; 0<=j && j<a.length; list[i] == a[j]));
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable */int[] a) {
		removeDup(a);
	}

	void removeDup(/*@ nullable */int[] a) {
		int[] result = new int[a.length];

		int p = 0;
		int len = a.length;
		int k = 0;
		/*@ 
		  @ loop_invariant 0 <= p && p <= result.length;
		  @ loop_invariant (\forall int v; 0<=v && v<p; (\exists int j; 0<=j && j<a.length; result[v] == a[j]));
		  @ assignable result[*];
		  @*/
		while (k < len) {
			boolean contains = false;
			int i = 0;
		   /*@ maintaining 0<=i && i<=p;
        	 @ maintaining (\forall int j; 0<=j && j<i; result[j] != a[k]);
        	 @ assignable \strictly_nothing;
        	@*/
			while (i < p) {
				if (result[i] == a[k]) {
					contains = true;
					break;
				}
				i = i + 1;
			}

			if (!contains) {
				result[p] = a[k];
				p = p + 1;
			}
			k = k + 1;
		}

		int[] re = new int[p];
		int t = 0;
		/*@ loop_invariant
		  @   0 <= t && t <= p &&
		  @   (\forall int j; 0<=j && j < t; re[j] == result[j]);
		  @ assignable re[*];
		  @*/
		while (t < p) {
			re[t] = result[t];
			t = t + 1;
		}
		list = re;

	}
}
