package functional.list.leElems;

final class List {

	/*@ nullable @*/ int[] list;

	/*@ 
	  @ requires a!=null && a.length >= 0;
	  @ ensures list.length <= a.length;	  
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable */int[] a) {
		removeDup(a);
	}

	void removeDup(/*@ nullable */int[] a) {
		int[] result = new int[a.length];

		int p = 0;
		int len = a.length;
		int k = 0;
		/*@ 
		  @ loop_invariant p<=len;
		  @ assignable result[*];
		  @*/
		while (k < len) {
			boolean contains = false;
			int i = 0;
			/*@ loop_invariant true;
		          @ assignable \strictly_nothing;
		          @*/
			while (i < p) {
				if (result[i] == a[k]) {
					contains = true;
					break;
				}
				i = i + 1;
			}

			if (!contains) {
				result[p] = a[k];
				p = p + 1;
			}
			k = k + 1;
		}

		int[] re = new int[p];
		int t = 0;
		/*@ loop_invariant true;
		  @ assignable re[*];
		  @*/
		while (t < p) {
			re[t] = result[t];
			t = t + 1;
		}
		list = re;

	}
}
