package abstraction.dictionary.NullPointerException;

import abstraction.RuntimeException;

final class Dictionary {
	/*@ nullable @*/Key[] keys;
	/*@ nullable @*/Value[] values;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires keys != null && values != null;
	  @ requires (\forall int i,j; 0<=i && i<j && j<keys.length; keys[i] != keys[j]);
	  @ requires keys.length == values.length;
	  @ requires 0<=keys.length && keys.length<Integer.MAX_VALUE;
	  @ ensures !RuntimeException.NullPointerException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		put(k, v);
	}

	void put(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		if (this.keys == null) {
			RuntimeException.NullPointerException = true;
			return;
		}

		if ( pure_boolean() ) { //		if (pos >= 0) {
			if (this.values == null) {
				RuntimeException.NullPointerException = true;
				return;
			}
			this.values[pure_int()] = pure_Value(); //			this.values[pos] = v;
		} else {
			impure_keys_values();
		}
	}
	/*@ assignable \strictly_nothing; @*/
	native Value /*@ helper @*/ pure_Value();
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ pure_boolean();
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ pure_int();
	/*@ assignable \strictly_nothing; @*/
	native void /*@ helper @*/ pure_void();
	/*@ assignable keys, values; @*/
	native void /*@ helper @*/ impure_keys_values();
}
