package abstraction.lrs.ArrayIndexOutOfBoundsException;

import abstraction.RuntimeException;

final class LRS {
	int s = 0;
	int t = 0;
	int l = 0;
	/*@ nullable */SuffixArray sa;

	/*@ 
	  @ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires sa!=null && sa.a != null && sa.suffixes != null;
	  @ requires sa.a.length >= 2;
	  @// from class invariants
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; (\exists int j; 0 <= j && j < sa.a.length; sa.suffixes[j]==i));
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; sa.suffixes[i-1] != sa.suffixes[i]);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; 
	  @   (sa.a != null && 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length && 0 <= sa.suffixes[i-1] && sa.suffixes[i-1] < sa.a.length) 
	  @	  ==> (\exists int j; 0 <= j && j < sa.a.length-sa.suffixes[i];
	  @           ((j < sa.a.length-sa.suffixes[i-1] && sa.a[sa.suffixes[i]+j] > sa.a[sa.suffixes[i-1]+j] ) || j == sa.a.length-sa.suffixes[i-1])
	  @               && (\forall int k; 0 <= k && k < j; sa.a[sa.suffixes[i]+k] == sa.a[sa.suffixes[i-1]+k])));
	  @ requires sa.a.length == sa.suffixes.length;
	  @ ensures !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ int[] array) {
		doLRS(array);
	}

	void doLRS(int[] array) {
		int len = sa.a.length;

		int[] suffixA = sa.suffixes;

		int x = 1;
		/*@ maintaining 1<=x && x<=len;
		  @ assignable \strictly_nothing;
		 */
		while (x < len) {
			if (x < 0 || x >= suffixA.length) {
				RuntimeException.ArrayIndexOutOfBoundsException = true;
				return;
			}
			int begin = suffixA[x];

			if (x - 1 < 0 || x - 1 >= suffixA.length) {
				RuntimeException.ArrayIndexOutOfBoundsException = true;
				return;
			}
			int end = suffixA[x - 1];

			int length = 0;

			int tLength = sa.a.length;
			/*@
			  @ maintaining true;
			  @ assignable \strictly_nothing;
			 */
			while (begin + length < tLength && end + length < tLength) {
				if (begin + length < 0 && begin + length >= tLength) {
					RuntimeException.ArrayIndexOutOfBoundsException = true;
					return;
				}
				if (end + length < 0 && end + length >= tLength) {
					RuntimeException.ArrayIndexOutOfBoundsException = true;
					return;
				}
				if ( pure_boolean() ) { //					if (aA[begin + length] == aA[end + length]){
					length = pure_int(); //						length = length + 1;
				}else{
					break;
				}
			}

			x = x + 1;
		}
		impure_s_t_l();
	}
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ pure_boolean();
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ pure_int();
	/*@ assignable \strictly_nothing; @*/
	native void /*@ helper @*/ pure_void();
	/*@ assignable s,t,l; @*/
	native void /*@ helper @*/ impure_s_t_l();
}
