package abstraction.lrs.NullPointerException;

import abstraction.RuntimeException;

final class LRS {
	int s = 0;
	int t = 0;
	int l = 0;
	/*@ nullable */SuffixArray sa;

	/*@ 
	  @ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires sa!=null && sa.a != null && sa.suffixes != null;
	  @ requires sa.a.length >= 2;
	  @// from class invariants
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; (\exists int j; 0 <= j && j < sa.a.length; sa.suffixes[j]==i));
	  @ requires (\forall int i; 0 <= i && i < sa.a.length; 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; sa.suffixes[i-1] != sa.suffixes[i]);
	  @ requires (\forall int i; 0 < i && i < sa.a.length; 
	  @   (sa.a != null && 0 <= sa.suffixes[i] && sa.suffixes[i] < sa.a.length && 0 <= sa.suffixes[i-1] && sa.suffixes[i-1] < sa.a.length) 
	  @	  ==> (\exists int j; 0 <= j && j < sa.a.length-sa.suffixes[i];
	  @           ((j < sa.a.length-sa.suffixes[i-1] && sa.a[sa.suffixes[i]+j] > sa.a[sa.suffixes[i-1]+j] ) || j == sa.a.length-sa.suffixes[i-1])
	  @               && (\forall int k; 0 <= k && k < j; sa.a[sa.suffixes[i]+k] == sa.a[sa.suffixes[i-1]+k])));
	  @ requires sa.a.length == sa.suffixes.length;
	  @ ensures !RuntimeException.NullPointerException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ int[] array) {
		doLRS(array);
	}

	void doLRS(int[] array) {
		if (sa == null) {
			RuntimeException.NullPointerException = true;
			return;
		}
		if (sa.a == null) {
			RuntimeException.NullPointerException = true;
			return;
		}
		int[] suffixA = sa.suffixes;
		if (suffixA == null) {
			RuntimeException.NullPointerException = true;
			return;
		}
		this.s = _int(); //		this.s = s;
		this.t = _int(); //		this.t = t;
		this.l = _int(); //		this.l = l;
	}
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ _int();
}
