package abstraction.list.NegativeArraySizeException;

import abstraction.RuntimeException;

final class List {

	/*@ nullable @*/ int[] list;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires a!=null && a.length >= 0;
	  @ ensures !RuntimeException.NegativeArraySizeException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable */int[] a) {
		removeDup(a);
	}
	
	void removeDup(/*@ nullable */int[] a) {
		if (a.length < 0) {
			RuntimeException.NegativeArraySizeException = true;
			return;
		}
		int[] result = new int[a.length];

		int p = 0;
		int len = a.length;
		int k = 0;
                //@ loop_invariant p >= 0;
                //@ assignable k, p, result[*];
		while (k < len) {
			boolean contains = false;
			int i = 0;
                        //@ loop_invariant true;
                        //@ assignable i, contains;
			while (i < p) {
				if (result[i] == a[k]) {
					contains = true;
					break;
				}
				i = i + 1;
			}

			if (!contains) {
				result[p] = a[k];
				p = p + 1;
			}
			k = k + 1;
		}

		if (p < 0) {
			RuntimeException.NegativeArraySizeException = true;
			return;
		}
		int[] re = new int[p];
		int t = 0;
                //@ loop_invariant true;
                //@ assignable re[*], t;
		while (t < p) {
			re[t] = result[t];
			t = t + 1;
		}
		list = re;

	}
}
