package abstraction.set.NullPointerException;

import abstraction.RuntimeException;

final class Set {
	/*@ nullable @*/int[] items;
	/*@ nullable @*/ Set res;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires this.items != null;
	  @ requires (\forall int i, j; 0<=i && i<this.items.length && 0<=j && j<this.items.length && i!=j; this.items[i] != this.items[j]);
	  @ requires 0 <= this.items.length;
	  @ requires p!=null && p.items != null;
	  @ requires (\forall int i, j; 0<=i && i<p.items.length && 0<=j && j<p.items.length && i!=j; p.items[i] != p.items[j]);
	  @ requires 0 <= p.items.length;
	  @ ensures !RuntimeException.NullPointerException;
	  @ assignable \everything;
	  @ diverges true;
	  @*/
	void wrapper(/*@ nullable @*/ Set p){
		intersect(p);
	}

	void intersect(/*@ nullable @*/ Set p) {
		res = new Set();
		res.items = new int[0];
		if (this.items == null) {
			RuntimeException.NullPointerException = true;
			return;
		}
		int len = this.items.length;
		int index = 0;                
                //@ loop_invariant res !=null && res.items !=null;
                //@ assignable res.items, res.items[*];
		while (index < len) {
			if (this.items == null) {
				RuntimeException.NullPointerException = true;
				return;
			}
			int v = this.items[index];
			boolean found = false;
			if (p == null) {
				RuntimeException.NullPointerException = true;
				return;
			}
			if (p.items == null) {
				RuntimeException.NullPointerException = true;
				return;
			}
			int pLen = p.items.length;
			int pIndex = 0;
                        //@ loop_invariant true;
                        //@ assignable \strictly_nothing;
			while (pIndex < pLen) {
				if (p.items[pIndex] == v) {
					found = true;
					break;

				}
				pIndex = pIndex + 1;
			}

			if (found) {
				boolean resFound = false;
				if (res.items == null) {
					RuntimeException.NullPointerException = true;
					return;
				}
				int resLenF = res.items.length;
				int resIndexF = 0;
                                //@ loop_invariant true;
                                //@ assignable \strictly_nothing;
				while (resIndexF < resLenF) {
					if (res.items[resIndexF] == v) {
						resFound = true;
						break;
					}
					resIndexF = resIndexF + 1;
				}

				if (!resFound) {
					int resLen = res.items.length;

					int[] newList = new int[resLen + 1];
					int resIndex = 0;
                                        //@ loop_invariant true;
                                        //@ assignable newList[*];
					while (resIndex < resLen) {
						newList[resIndex] = res.items[resIndex];
						resIndex = resIndex + 1;
					}
					newList[resIndex] = v;
					res.items = newList;
				}
			}
			index = index + 1;
		}
	}
}
